searchNodes=[{"doc":"Client for Mixpanel Ingestion API. It provides a sync API that makes HTTP request to the Mixpanel API. And also a async API that buffers and delivers the buffered events to Mixpanel in background. Checkout the documentation for more information. Installation The package can be installed by adding mxpanel to your list of dependencies in mix.exs : def deps do [ { :mxpanel , &quot;~&gt; 0.3.0&quot; } , { :jason , &quot;~&gt; 1.2&quot; } , { :hackney , &quot;~&gt; 1.17&quot; } ] end Examples # Create a client struct with your project token client = % Mxpanel.Client { token : &quot;&lt;mixpanel project token&gt;&quot; } # track an event event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;billybob&quot; ) Mxpanel . track ( client , event ) # track an event with optional properties event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;billybob&quot; , %{ &quot;Favourite Color&quot; =&gt; &quot;Red&quot; } ) Mxpanel . track ( client , event ) # set an IP address to get automatic geolocation info event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;billybob&quot; , %{ } , ip : &quot;72.229.28.185&quot; ) Mxpanel . track ( client , event ) # track an event with a specific timestamp event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;billybob&quot; , %{ } , time : System . os_time ( :second ) - 60 ) Mxpanel . track ( client , event ) # track an event in background, the event will be buffered, and later sent in batches Mxpanel.Batcher . start_link ( name : MyApp.Batcher , token : &quot;&lt;mixpanel project token&gt;&quot; ) event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;billybob&quot; ) Mxpanel . track_later ( MyApp.MxpanelBatcher , event ) # Create an alias for an existing distinct id Mxpanel . create_alias ( client , &quot;distinct_id&quot; , &quot;your_alias&quot; ) # create or update a user in Mixpanel Engage properties = %{ &quot;Address&quot; =&gt; &quot;1313 Mockingbird Lane&quot; , &quot;Birthday&quot; =&gt; &quot;1948-01-01&quot; } Mxpanel.People . set ( client , &quot;billybob&quot; , properties ) # create or update a user in Mixpanel Engage without altering $last_seen Mxpanel.People . set ( client , &quot;billybob&quot; , %{ plan : &quot;premium&quot; } , ignore_time : true ) # set a user profile&#39;s IP address to get automatic geolocation info Mxpanel.People . set ( client , &quot;billybob&quot; , %{ plan : &quot;premium&quot; } , ip : &quot;72.229.28.185&quot; ) # set properties on a user, don&#39;t override properties = %{ &quot;First login date&quot; =&gt; &quot;2013-04-01T13:20:00&quot; } Mxpanel.People . set_once ( client , &quot;billybob&quot; , properties ) # removes the properties Mxpanel.People . unset ( client , &quot;billybob&quot; , [ &quot;Address&quot; , &quot;Birthday&quot; ] ) # increment a numeric property Mxpanel.People . increment ( client , &quot;billybob&quot; , &quot;Number of Logins&quot; , 12 ) # append value to a list Mxpanel.People . append_item ( client , &quot;billybob&quot; , &quot;Items purchased&quot; , &quot;socks&quot; ) # remove value from a list Mxpanel.People . remove_item ( client , &quot;billybob&quot; , &quot;Items purchased&quot; , &quot;t-shirt&quot; ) # delete a user Mxpanel.People . delete ( client , &quot;billybob&quot; ) Telemetry Mxpanel currently exposes following Telemetry events: [:mxpanel, :batcher, :buffers_info] - Dispatched periodically by each running batcher exposing the size of each running buffer in the pool. Measurement: %{} Metadata: %{batcher_name: atom(), buffer_sizes: [integer()]} Changelog See the changelog .","ref":"Mxpanel.html","title":"Mxpanel","type":"module"},{"doc":"Creates an alias for an existing distinct id. Mxpanel . create_alias ( client , &quot;distinct_id&quot; , &quot;your_alias&quot; )","ref":"Mxpanel.html#create_alias/3","title":"Mxpanel.create_alias/3","type":"function"},{"doc":"Returns the configured JSON encoding library for Mxpnale (defaults to Jason). To customize the JSON library, including the following in your config/config.exs: config :mxpanel , :json_library , Jason","ref":"Mxpanel.html#json_library/0","title":"Mxpanel.json_library/0","type":"function"},{"doc":"Send a single event into Mixpanel. client = % Mxpanel.Client { token : &quot;mixpanel project token&quot; } event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) Mxpanel . track ( client , event ) Import a batch of events into Mixpanel. client = % Mxpanel.Client { token : &quot;mixpanel project token&quot; } event_1 = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) event_2 = Mxpanel.Event . new ( &quot;signup&quot; , &quot;456&quot; ) Mxpanel . track ( client , [ event_1 , event_2 ] )","ref":"Mxpanel.html#track/2","title":"Mxpanel.track/2","type":"function"},{"doc":"Enqueues the event. The event will be store in a buffer and sent in batches to mixpanel. Mxpanel.Batcher . start_link ( name : MyApp.MxpanelBatcher , token : &quot;mixpanel project token&quot; ) event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) Mxpanel . track_later ( MyApp.MxpanelBatcher , event ) Why use it? HTTP requests to the Mixpanel API often take time and may fail. If you are tracking events during a web request, you probably, don't want to make your users wait the extra time for the mixpanel API call to finish. Checkout Mxpanel.Batcher for more information.","ref":"Mxpanel.html#track_later/2","title":"Mxpanel.track_later/2","type":"function"},{"doc":"Manages a pool of buffers that accumulate the events and sends them to the Mixpanel API in batches in background. It implements a registry-based routing pool with round-robing as routing strategy. Checkout start_link/1 for all supported options. Usage Add to your supervision tree: { Mxpanel.Batcher , name : MyApp.Batcher , token : &quot;mixpanel project token&quot; } Enqueue an event: Mxpanel . track_later ( MyApp.MxpanelBatcher , event ) The event will be buffered, and later sent in batch to the Mixpanel API.","ref":"Mxpanel.Batcher.html","title":"Mxpanel.Batcher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mxpanel.Batcher.html#child_spec/1","title":"Mxpanel.Batcher.child_spec/1","type":"function"},{"doc":"Synchronously drain all buffers in the batcher. Returns a list containing all the processed events. Mxpanel.Batcher . drain_buffers ( MyApp.Batcher )","ref":"Mxpanel.Batcher.html#drain_buffers/1","title":"Mxpanel.Batcher.drain_buffers/1","type":"function"},{"doc":"Starts a Mxpanel.Batcher linked to the current process. Supported options :name - Required. Name of the batcher instance. :token - Required if active. The Mixpanel token associated with your project. :active - Configure Batcher to be active or not. Useful for disabling requests in certain environments. The default value is true . :base_url - Mixpanel API URL The default value is &quot;https://api.mixpanel.com&quot; . :http_client - HTTP client used by the Batcher. The default value is {Mxpanel.HTTPClient.HackneyAdapter, []} . :pool_size - The size of the pool of event buffers. The default value is 10 . :flush_interval - Interval in milliseconds which the event buffer are processed. The default value is 5000 . :flush_jitter - Jitter the flush interval by a random amount. Value in milliseconds. This is primarily to avoid large write spikes. For example, a flush_jitter of 1s and flush_interval of 1s means flushes will happen every 5-6s. The default value is 1000 . :retry_max_attempts - Max attempts that a batch of events should be tried before giving up. The default value is 5 . :retry_base_backoff - Base time in milliseconds to calculate the wait time between retry attempts. Formula: (attempt * retry_base_backoff) + random(1..retry_base_backoff) . The default value is 100 . :import_timeout - The maximum amount of time in milliseconds each batch of events is allowed to execute for. The default value is 30000 . :telemetry_buffers_info_interval - Interval in milliseconds the telemetry with the buffers info is published. The default value is 30000 . :debug - Enable debug logging. The default value is false .","ref":"Mxpanel.Batcher.html#start_link/1","title":"Mxpanel.Batcher.start_link/1","type":"function"},{"doc":"","ref":"Mxpanel.Batcher.html#t:name/0","title":"Mxpanel.Batcher.name/0","type":"type"},{"doc":"Struct representing a Mxpanel Client. Default Usage % Mxpanel.Client { token : &quot;project_token&quot; } EU API % Mxpanel.Client { token : &quot;project_token&quot; , base_url : &quot;api-eu.mixpanel.com&quot; } Custom HTTP client You can switch the default HTTP client ( Mxpanel.HTTPClient.HackneyAdapter ) which uses hackney underneath by defining a different implementation by setting the :http_client option: % Mxpanel.Client { http_client : { MyCustomHTTPClient , [ ] } , token : &quot;token&quot; }","ref":"Mxpanel.Client.html","title":"Mxpanel.Client","type":"module"},{"doc":"","ref":"Mxpanel.Client.html#t:t/0","title":"Mxpanel.Client.t/0","type":"type"},{"doc":"Struct representing a Mixpanel Event","ref":"Mxpanel.Event.html","title":"Mxpanel.Event","type":"module"},{"doc":"Create a new event. Mxpanel.Event . new ( &quot;signup&quot; , &quot;13793&quot; ) Mxpanel.Event . new ( &quot;signup&quot; , &quot;13793&quot; , %{ &quot;Favourite Color&quot; =&gt; &quot;Red&quot; } ) Mxpanel.Event . new ( &quot;signup&quot; , &quot;13793&quot; , %{ } , ip : &quot;72.229.28.185&quot; ) Mxpanel.Event . new ( &quot;signup&quot; , &quot;13793&quot; , %{ } , time : 1624811298 ) Options :time - Specific timestamp in seconds of the event. Defaults to System.os_time(:second) . :ip - IP address to get automatic geolocation info.","ref":"Mxpanel.Event.html#new/4","title":"Mxpanel.Event.new/4","type":"function"},{"doc":"Serialize a event into the format expected by the Mixpanel API.","ref":"Mxpanel.Event.html#serialize/2","title":"Mxpanel.Event.serialize/2","type":"function"},{"doc":"","ref":"Mxpanel.Event.html#t:t/0","title":"Mxpanel.Event.t/0","type":"type"},{"doc":"Specifies the behaviour of a HTTP Client.","ref":"Mxpanel.HTTPClient.html","title":"Mxpanel.HTTPClient","type":"behaviour"},{"doc":"Sends an HTTP request.","ref":"Mxpanel.HTTPClient.html#c:request/5","title":"Mxpanel.HTTPClient.request/5","type":"callback"},{"doc":"Mxpanel.HTTPClient adapter for hackney . Remember to add {:hackney, &quot;~&gt; 1.17&quot;} to dependencies. Also, you need to recompile mxpanel after adding the :hackney dependency: mix deps . clean mxpanel mix compile","ref":"Mxpanel.HTTPClient.HackneyAdapter.html","title":"Mxpanel.HTTPClient.HackneyAdapter","type":"module"},{"doc":"Functions to manipulate user profiles. Shared Options All of the functions in this module accept the following options: :ip - IP address to get automatic geolocation info. :ignore_time - Prevent the $last_seen property from incorrectly updating user profile properties with misleading timestamps in server-side Mixpanel implementations. :time - Specific timestamp in seconds of the event. Defaults to System.os_time(:second) .","ref":"Mxpanel.People.html","title":"Mxpanel.People","type":"module"},{"doc":"Appends the item to a list associated with the corresponding property name. Appending to a property that doesn't exist will result in assigning a list with one element to that property. Mxpanel.People . append_item ( client , &quot;13793&quot; , &quot;Items purchased&quot; , &quot;socks&quot; )","ref":"Mxpanel.People.html#append_item/5","title":"Mxpanel.People.append_item/5","type":"function"},{"doc":"Permanently delete the profile from Mixpanel, along with all of its properties. Mxpanel.People . delete ( client , &quot;13793&quot; ) If you have duplicate profiles, set ignore_alias to true so that you don't delete the original profile when trying to delete the duplicate. Mxpanel.People . delete ( client , &quot;user@mail.com&quot; , ignore_alias : true )","ref":"Mxpanel.People.html#delete/3","title":"Mxpanel.People.delete/3","type":"function"},{"doc":"Increment the value of a user profile property. When processed, the property values are added to the existing values of the properties on the profile. If the property is not present on the profile, the value will be added to 0. It is possible to decrement by calling with negative values. Mxpanel.People . increment ( client , &quot;13793&quot; , &quot;Number of Logins&quot; , 12 )","ref":"Mxpanel.People.html#increment/5","title":"Mxpanel.People.increment/5","type":"function"},{"doc":"Removes an item from a existing list on the user profile. If it does not exist, no updates are made. Mxpanel.People . append_item ( client , &quot;13793&quot; , &quot;Items purchased&quot; , &quot;t-shirt&quot; )","ref":"Mxpanel.People.html#remove_item/5","title":"Mxpanel.People.remove_item/5","type":"function"},{"doc":"Sets properties for a profile identified by its distinct_id . If the profile does not exist, it creates it with these properties. If it does exist, it sets the properties to these values, overwriting existing values. properties = %{ &quot;Address&quot; =&gt; &quot;1313 Mockingbird Lane&quot; , &quot;Birthday&quot; =&gt; &quot;1948-01-01&quot; } Mxpanel.People . set ( client , &quot;13793&quot; , properties )","ref":"Mxpanel.People.html#set/4","title":"Mxpanel.People.set/4","type":"function"},{"doc":"Works just like set/4 except it will not overwrite existing property values. This is useful for properties like &quot;First login date&quot;. properties = %{ &quot;First login date&quot; =&gt; &quot;2013-04-01T13:20:00&quot; } Mxpanel.People . set_once ( client , &quot;13793&quot; , properties )","ref":"Mxpanel.People.html#set_once/4","title":"Mxpanel.People.set_once/4","type":"function"},{"doc":"Takes a list of property names, and permanently removes the properties and their values from a profile. property_names = [ &quot;Address&quot; , &quot;Birthday&quot; ] Mxpanel.People . unset ( client , &quot;13793&quot; , property_names )","ref":"Mxpanel.People.html#unset/4","title":"Mxpanel.People.unset/4","type":"function"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Added Examples section to readme. Mxpanel.create_alias/3 . Mxpanel.People.append_item/5 . Mxpanel.People.delete/3 . Mxpanel.People.increment/5 . Mxpanel.People.remove_item/5 . Mxpanel.People.set/4 . Mxpanel.People.set_once/4 . Mxpanel.People.unset/4 .","ref":"changelog.html#0-3-0-2021-06-28","title":"Changelog - 0.3.0 - 2021-06-28","type":"extras"},{"doc":"Support custom :ip and :time for track events. Simplify issue template. Improve :token validation, to allow nil values when inactive.","ref":"changelog.html#changed","title":"Changelog - Changed","type":"extras"},{"doc":"Changed retry_max_attempts options of Mxpanel.Batcher increased from 3 to 5 . Support batch of events in Mxpanel.track/2 and Mxpanel.track_later/2 . Added Mxpanel.Batcher.drain_buffers/1 . active option to Mxpanel.Batcher . debug option to Mxpanel.Batcher . Removed finch Mxpanel.HTTPClient adapter. Mxpanel.track_many/2 .","ref":"changelog.html#0-2-0-2021-06-21","title":"Changelog - 0.2.0 - 2021-06-21","type":"extras"},{"doc":"Added Mxpanel.track/2 . Mxpanel.track_many/2 . Mxpanel.track_later/2 .","ref":"changelog.html#0-1-0-2021-06-16","title":"Changelog - 0.1.0 - 2021-06-16","type":"extras"}]